import java.util.Iterator;
import static org.junit.Assert.*;

import org.junit.AfterClass;
import org.junit.Test;

public class Testing {
	
	private static int points = 0;
	

@Test
public void testReverse(){
	BinarySearchTree<Integer> b = new BinarySearchTree<>();
	b.insert(15);
	b.reverse();
	Iterator<BinarySearchTree<Integer>.BinaryNode> it = b.preOrderIterator();
	BinarySearchTree<Integer>.BinaryNode temp;
	assertTrue(it.hasNext());
	temp = it.next();
	assertEquals(new Integer(15), temp.getElement());
	points += 1;
		
	b = new BinarySearchTree<>();
	b.insert(15);
	b.insert(10);
	b.insert(20);
	b.reverse();
	it = b.preOrderIterator();
	assertTrue(it.hasNext());
	temp = it.next();
	assertEquals(new Integer(15), temp.getElement());
	assertTrue(it.hasNext());
	temp = it.next();
	assertEquals(new Integer(20), temp.getElement());
	assertTrue(it.hasNext());
	temp = it.next();
	assertEquals(new Integer(10), temp.getElement());
	points += 4;
	
	b = new BinarySearchTree<>();
	b.insert(15);
	b.insert(10);
	b.insert(20);
	b.insert(12);
	b.insert(17);
	b.reverse();
	it = b.preOrderIterator();
	assertTrue(it.hasNext());
	temp = it.next();
	assertEquals(new Integer(15), temp.getElement());
	assertTrue(it.hasNext());
	temp = it.next();
	assertEquals(new Integer(20), temp.getElement());
	assertTrue(it.hasNext());
	temp = it.next();
	assertEquals(new Integer(17), temp.getElement());
	assertTrue(it.hasNext());
	temp = it.next();
	assertEquals(new Integer(10), temp.getElement());
	assertTrue(it.hasNext());
	temp = it.next();
	assertEquals(new Integer(12), temp.getElement());
	points += 5;
	
	b = new BinarySearchTree<Integer>();
	for (int i = 1; i < 1000; i++) b.insert(i);
	b.reverse();
	it = b.preOrderIterator();
	for (int i = 1; i < 999; i++) {
		assertTrue(it.hasNext());
		temp = it.next();
		assertTrue(temp.getLeftChild() != null);
		assertEquals(new Integer(i), temp.getElement());
	}
	assertTrue(it.hasNext());
	temp = it.next();
	assertEquals(new Integer(999), temp.getElement());
	points += 5;
	
	b = new BinarySearchTree<Integer>();
	for (int i = 999; i >= 1; i--) b.insert(i);
	b.reverse();
	it = b.preOrderIterator();
	for (int i = 999; i >= 2; i--) {
		assertTrue(it.hasNext());
		temp = it.next();
		assertTrue(temp.getRightChild() != null);
		assertEquals(new Integer(i), temp.getElement());
	}
	assertTrue(it.hasNext());
	temp = it.next();
	assertEquals(new Integer(1), temp.getElement());
	points += 5;
	
	b = new BinarySearchTree<Integer>();
	int size = 1048576;
	int v = size / 2;
	int tempp;
	while (v > 0) {
		tempp = v;
		while (tempp < size){
			b.insert(tempp+1);
			tempp += v;
			}
		v = v / 2;
	}
	b.reverse();
	it = b.preOrderIterator();
	for (int i = 1; i < 1048576; i++) {
		assertTrue(it.hasNext());
		temp = it.next();
		if (temp.getLeftChild() != null) {
			assertTrue(temp.getLeftChild().getElement().compareTo(temp.getElement()) > 0);
		}
		if (temp.getRightChild() != null) {
			assertTrue(temp.getRightChild().getElement().compareTo(temp.getElement()) < 0);
		}
	}
	points += 5;


}

	@Test
	public void testIsAVLTree(){
		BinarySearchTree<Integer> b = new BinarySearchTree<Integer>();
		assertTrue(b.isAVLTree());
		points += 1;
		
		b.insert(10);
		assertTrue(b.isAVLTree());
		points += 1;
		
		b.insert(15);
		assertTrue(b.isAVLTree());
		points += 1;
		
		b.insert(20);
		assertFalse(b.isAVLTree());
		points += 1;
		
		b.insert(5);
		assertTrue(b.isAVLTree());
		points += 1;
		
		b.insert(7);		
		assertTrue(b.isAVLTree());
		points += 1;
		
		b.insert(9);
		assertFalse(b.isAVLTree());
		points += 1;
		
		b.insert(6);
		assertFalse(b.isAVLTree());
		points += 2;
		
		b.insert(4);
		assertTrue(b.isAVLTree());
		points += 2;
		
		b.insert(3);
		assertTrue(b.isAVLTree());
		
		b.insert(8);
		assertFalse(b.isAVLTree());
		points += 2;
		
		b = new BinarySearchTree<Integer>();
		int size = 1048576;
		int v = size / 2;
		int temp;
		while (v > 0) {
			temp = v;
			while (temp < size){
				b.insert(temp+1);
				temp += v;
				}
			v = v / 2;
		}
		assertTrue(b.isAVLTree());
		points += 4;
		
		b.insert(1);
		assertTrue(b.isAVLTree());
		points += 4;
		
		b.insert(0);
		assertFalse(b.isAVLTree());
		points += 4;
	}
	
	
	@AfterClass
	public static void testDoNothing(){
		System.out.println("Points: " + points);
	}

	
}